/////////////////////////////////////////////////////////////////////////
//
// File: warjo_pscript.h
//
// Description:
//		PureScript class declaration
//		
//
#ifndef WJ_PSCRIPT_H
#define WJ_PSCRIPT_H

#include <vector>
#include "warjo_singleton.h"

////////////////////////////////////////////////////////////////////
//
// Mapping types
// 
#define T_FLOAT  1
#define T_INT	 2
#define T_STRING 3
#define T_VFUNC	16

//******************************************************************
//
// PureScript class
//
class PureScript:public Singleton<PureScript> {

	//internal data structure for map entry
	typedef struct {
		unsigned char type;
		char name[64]; //maximum 32 chars
		void *pv;      //pointer to the variable 
	} ENTRY;

	//STL vector defines
	typedef std::vector<ENTRY> VENTRY;
	typedef std::vector<ENTRY>::iterator VIENTRY;
	
	//the collection
	VENTRY entries;

	//buffer
	char buf[1024];

	//file parsing
	void pre_process();
	void parse_line();
public:

	//mapping functions
	void Map(float *pvar,char *name);
	void Map(int *pvar,char *name);
	void Map(char *pvar,char *name);
	void Mapf(void (*func)(),char *name);
	
	//load the text file
	void Load(char *filename);

	//helper
	static bool GetStrN(int n,char *szsrc,char *szdst);
};

//global define
#define g_pscript PureScript::GetSingleton()

#endif